86 => global int WATERFALL_DEPTH; // waterfall depth; number of lines deep
100 => global int numGlitter;
1024 => global int WINDOW_SIZE;
0.0 => global float maxXPos;

public class Waterfall extends GGen {
    0 => int playhead; // waterfall playhead
    GPoints wfl[WATERFALL_DEPTH]; // lines
    Spark sunGlitter --> GG.scene();
    Surfer pika --> GG.scene();

    float heights[numGlitter];
    numGlitter * -1 => int glitterInd;

    for( GPoints w : wfl ) { // iterate over line GGens
        w --> this; // aww yea, connect as a child of this GGen
    }

    // update position of each waterfall frequency, the glitter, and the heart surfer
    fun void latest( vec3 positions[], int maxInd ) {
        if(glitterInd >= WINDOW_SIZE) -99 => glitterInd;
        positions => wfl[playhead].geo().positions; // set line mesh's position
        sunGlitter.latest(positions, glitterInd) @=> heights;
        glitterInd + 5 => glitterInd;
        pika.updateSurf(heights, numGlitter);
        playhead++; // advance playhead
        WATERFALL_DEPTH %=> playhead; // wrap it. mod playhead by waterfall depth and assign it to playhead
    }

    // update
    fun void update( float dt ) {
        playhead => int pos; // position
        5 => float thresh;
        WATERFALL_DEPTH - thresh => float fadeChunk; // depth
        
        for( int i; i < wfl.size(); i++ ) { // start with playhead-1 and go backwards
            pos--; if( pos < 0 ) WATERFALL_DEPTH-1 => pos;
            if (i == 0) {
                wfl[pos].posY(.38 * Math.log((.001 * i) + 0.0001) + .66);
            } else {
                wfl[pos].posY(.38 * Math.log((.001 * i) + 0.0001));
            }
            wfl[pos].posZ(2.5);
            wfl[pos].mat().color( @((0.25 * fadeChunk / i ), 1, 1) ); //from white to cyan
        }
    }

    //the heart "spark" or wave "glitter"
    class Spark extends GGen {
        GPlane max[numGlitter]; //established by global var
        float heights[numGlitter];

        for (GPlane p : max) {
            p --> GG.scene();
        }

        // update the position and height of each plane in the spark
        fun float[] latest(vec3 positions[], int start) {
            heights.zero();
            for(0 => int i; i < numGlitter; i++) {
                start + i => int ind;
                if (ind >= positions.size()) {
                    positions.size() - 1 => ind;
                    positions[ind - 1].x + 0.5 => maxXPos;
                } else if (ind >= 0) {
                    max[i].posX(positions[ind].x);
                    max[i].posY(positions[ind].y - 2.748);
                    max[i].posZ(2.51);
                    max[i].mat().color(@(1,.6,0));
                    max[i].scaX(.015);
                    max[i].scaY(positions[ind].y * -1);
                    positions[ind].y => heights[i];
                    positions[ind].x => maxXPos;
                }
            }
            return heights;
        }
    }

    //the heart shape surfer
    class Surfer extends GGen {
        GCircle pika --> GG.scene();
        pika.mat().color(@(0,0,0));
        pika.sca(.15);
        pika.posZ(2.52);

        //texture
        FlatMaterial matSurf;
        FileTexture bgSurf;
        bgSurf.path("heart.png");
        bgSurf.wrap(1, 1);
        matSurf.diffuseMap(bgSurf);
        pika.mat(matSurf);

        //set the surfer to be the end of the spark and at the average height of the spark
        fun void updateSurf(float heights[], int num) {
            getAvg(heights, num) => float avgHeight;
            pika.posY(avgHeight - 2.7482);
            pika.posX(maxXPos);
        }

        //get the average of the heights array
        fun float getAvg(float heights[], int num) {
            0.0 => float total;
            for (float h: heights) {
                total + h => total;
            }
            return total / num;
        }
        
    }
}
